# Python et les LLM

![tag](llm)
![category](python)

Il est possible de découvrir les joies des LLMs full local et d'interagir avec lui via un client python

Pour cela on va d'avord monter un serveur qui sera capable de répondre à un prompt et de lancer un LLM.

J'utilise pour cela ollama qui permet de lancer et sélectionner différent LLM et surtout on peut le lancer ce serveur via docker

> docker run -d -p 11434:11434 --name ollama ollama/ollama

on peut maintenant interagir avec notre serveur ollama via des api rest ... et il existe un module python permettant de faire ces appels

> pip install ollama

```python
from ollama import Client
client = Client(host='http://localhost:11434')
client.pull('llama3.1') #permet de charger le modele llama 3.1
response = client.chat(model='llama3.1', messages=[
  {
    'role': 'user',
    'content': 'Comment vas tu?',
  },
])
print(response)
```

perso je n'ai pas une machine puissante avec une carte graphique type nvdia ou AMD (qui permet d'accelerer les réponses via une installation spécifique de docker)
donc tous ce fait via cpu.


Il faut alors pour chercher l'optimisation miser sur des modèles plus petit ... allama en propose plein j'utilise souvent **phi3** ou **phi3.5**

C'est un début qui va nous permettre d'utiliser la capacité d'un modèle a générer des phrases dans un certain contexte

pour un code en mode chat dans une console en reprenant l'historique

```python
from ollama import Client
import asyncio
from ollama import AsyncClient

startprompt = ">>"
prompt = input(startprompt)
messages = []
while prompt != 'exit':
    async def chat():
        messages.append({'role': 'user', 'content': prompt})
        result = ""
        async for part in await AsyncClient(host='http://192.168.0.157:11434').chat(model='phi3', messages=messages, stream=True):
            result = result + part['message']['content'] + " "
            print(part['message']['content'], end='', flush=True)
        messages.append({'role': 'assistant', 'content': result})
        print("")

    asyncio.run(chat())
    prompt = input(startprompt)
```
